package org.cpas.prime;

// Les composants associs, http://compoasso.free.fr/primelistweb
//
// Generateur de jeux de test pour la division euclidienne
public class EuclideTestCaseGenerator {

	private final int maxTestCase;

	public EuclideTestCaseGenerator(int maxTestCase) {
		this.maxTestCase = maxTestCase;
	}

	public long[][] aleatoire() {

		System.out.println("Start Generation TestCase Aleatoire");

		double debut = System.currentTimeMillis();

		long[] testA = new long[maxTestCase];
		long[] testB = new long[maxTestCase];
		long lower = 1;
		long higher = 1000000000000L;

		int i = 0;
		while (i < maxTestCase) {
			long a = (long) (Math.random() * (higher - lower)) + lower;
			long b = (long) (Math.random() * (higher - lower)) + lower;
			testA[i] = a;
			testB[i] = b;
			i++;
		}

		double fin = System.currentTimeMillis();

		System.out.println("End Generation TestCase Aleatoire T: " + (fin - debut) / 1000d);

		long[][] test = { testA, testB };
		return test;
	}

	public long[][] aGtB() {

		System.out.println("Start Generation TestCase A > B");

		double debut = System.currentTimeMillis();

		long[] testA = new long[maxTestCase];
		long[] testB = new long[maxTestCase];
		long lower = 1;
		long higher = 1000000000000L;

		int i = 0;
		while (i < maxTestCase) {
			long a = (long) (Math.random() * (higher - lower)) + lower;
			long b = (long) (Math.random() * (higher - lower)) + lower;
			if (a > b) {
				testA[i] = a;
				testB[i] = b;
				i++;
			}
		}

		double fin = System.currentTimeMillis();

		System.out.println("End Generation TestCase A > B T: " + (fin - debut) / 1000d);

		long[][] test = { testA, testB };
		return test;
	}

	public long[][] custom() {

		System.out.println("Start Generation TestCase Custom");

		double debut = System.currentTimeMillis();

		long[] testA = new long[maxTestCase];
		long[] testB = new long[maxTestCase];
		long lower = 1L;
		long higher = 1000000000000L;

		int i = 0;
		while (i < maxTestCase) {
			long a = (long) (Math.random() * (higher - lower)) + lower;
			long b = (long) (Math.random() * (higher - lower)) + lower;
			if (a >= b * 4) {
				testA[i] = a;
				testB[i] = b;
				i++;
			}
		}

		double fin = System.currentTimeMillis();

		System.out.println("End Generation TestCase Custom T: " + (fin - debut) / 1000d);

		long[][] test = { testA, testB };
		return test;
	}
}
